<template>
  <v-card name="change-log">
    <v-toolbar
      color="teal"
    >
      <v-toolbar-title
        style="min-width: fit-content;"
      >
        <span class="title">Changelog</span>
      </v-toolbar-title>
      <v-spacer />
      <span style="font-size:16px;">
        Current version: {{ version }}
      </span>
      <v-btn
        icon
        @click="sendReq"
      >
        <v-icon v-if="!updating">
          refresh
        </v-icon>
        <v-progress-circular
          v-else
          indeterminate
          color="black"
          size="20"
        />
      </v-btn>
    </v-toolbar>
    <ul id="releaseList">
      <li
        v-for="release in releases"
        :key="release.tag_name"
      >
        <h2 style="margin: 2%;">
          Release: {{ release.tag_name }}
        </h2>
        <!-- eslint-disable-next-line -->
        <span class="releaseInfo" v-html="release.description_html"/>
        <v-divider />
      </li>
    </ul>
  </v-card>
</template>

<script lang="ts">
import Vue from 'vue'
import * as api from '@/api'
import { GitlabRelease } from '@/models'

const Changelog = Vue.extend({
  name: 'Changelog',
  data() {
    return {
      releases: [] as GitlabRelease[],
      version: '',
      updating: false,
    }
  },
  mounted() {
    this.sendReq()
  },
  methods: {
    async sendReq() {
      this.updating = true

      try {
        this.releases = await api.fetchReleases()
        this.version = (await api.fetchConfig()).version
        console.log(this.releases)
      }
      catch (ex) {
        throw new Error('Error fetching grady version.')
      } finally {
        this.updating = false
      }
    }
  }
})

export default Changelog
</script>

<style>
  .releaseInfo h2 {
    font-size: 19px;
  }
  ul {
    max-height: 350px;
    overflow: auto;
  }
</style>
